frr version 3.1+cl3u3
frr defaults datacenter
username cumulus nopassword
!
service integrated-vtysh-config
!
log syslog informational
!
{% set vrfs = [] %}
{% for irb in node[inventory_hostname]["overlay"]["irb"] -%}
{% if node[inventory_hostname]["overlay"]["irb"][irb]["vrf"] is defined %}
{% if [node[inventory_hostname]["overlay"]["irb"][irb]["vrf"]] not in vrfs %}
vrf {{node[inventory_hostname]["overlay"]["irb"][irb]["vrf"]}}
 vni 40{{node[inventory_hostname]["overlay"]["irb"][irb]["l3vni"]}}{% if node[inventory_hostname]["overlay"]["irb"][irb]["asymmetric"] is defined %}{% if node[inventory_hostname]["overlay"]["irb"][irb]["asymmetric"] %} prefix-routes-only {% endif %} {% endif %} 
{{ vrfs.append( [node[inventory_hostname]["overlay"]["irb"][irb]["vrf"]] ) }}
{% endif %}
{% endif %}
{% endfor %}
!
{% if node[inventory_hostname]["routing"]["bgp"]["underlay"] is defined %}
{% for interface in node[inventory_hostname]["routing"]["bgp"]["underlay"]["peers"] -%}
interface {{interface}}
 ipv6 nd ra-interval 10
 no ipv6 nd suppress-ra
!
{% endfor %}
{% endif %}

{% if node[inventory_hostname]["overlay"] is defined %}
{% for irb in node[inventory_hostname]["overlay"]["irb"] -%}
{% if node[inventory_hostname]["overlay"]["irb"][irb]["ipv6"] is defined %}
{% if node[inventory_hostname]["overlay"]["irb"][irb]["ipv6"]["VRRP"] is defined %}
interface vlan{{node["leaf02"]["overlay"]["irb"][irb]["l2vni"]}}-v0 vrf {{node[inventory_hostname]["overlay"]["irb"][irb]["vrf"]}} 
 ipv6 nd managed-config-flag
 ipv6 nd other-config-flag
 ipv6 nd prefix {{node[inventory_hostname]["overlay"]["irb"][irb]["ipv6"]["prefix"]}} 7200 1800 no-autoconfig
 ipv6 nd ra-interval 10
 ipv6 nd ra-lifetime 120
 no ipv6 nd suppress-ra
{% endif %}
{% endif %}
{% endfor %}
{% endif %}

{% if node[inventory_hostname]["routing"]["bgp"]["underlay"] is defined %}
router bgp {{ node[inventory_hostname]["routing"]["bgp"]["underlay"]["asn"] }}
 bgp router-id {{ node[inventory_hostname]["routing"]["lo"]|replace("/32", "")}}
 bgp bestpath as-path multipath-relax
 neighbor FABRIC peer-group
 neighbor FABRIC remote-as external
 neighbor FABRIC timers 1 3
{% for interface in node[inventory_hostname]["routing"]["bgp"]["underlay"]["peers"] -%}
 neighbor {{interface}} interface peer-group FABRIC
{% endfor -%}
 !
 address-family ipv4 unicast
  redistribute connected route-map loopbacks
 exit-address-family
 !
 address-family l2vpn evpn
   neighbor FABRIC activate
   advertise-all-vni
   advertise ipv4 unicast
   advertise ipv6 unicast
 exit-address-family
{% endif %}
!
{% if node[inventory_hostname]["routing"]["bgp"]["external"] is defined %}
{% for vrf in node[inventory_hostname]["routing"]["bgp"]["external"] %}
router bgp {{ node[inventory_hostname]["routing"]["bgp"]["external"][vrf]["asn"] }} vrf {{vrf}}
 bgp router-id {{ node[inventory_hostname]["routing"]["lo"]|replace("/32", "")}}
 neighbor FABRIC peer-group
 neighbor FABRIC remote-as external
{% if node[inventory_hostname]["routing"]["bgp"]["external"][vrf]["peers"] is defined %}
{% for peer in node[inventory_hostname]["routing"]["bgp"]["external"][vrf]["peers"] %}
 neighbor {{peer}} peer-group FABRIC
{% endfor %}
{% elif node[inventory_hostname]["routing"]["bgp"]["external"][vrf]["unnumbered_peers"] is defined %}
{% for peer in node[inventory_hostname]["routing"]["bgp"]["external"][vrf]["unnumbered_peers"] %}
 neighbor {{peer}} interface peer-group FABRIC
{% endfor %}
{% endif %}
 !
 address-family ipv4 unicast
  redistribute connected
 exit-address-family
 address-family ipv6 unicast
  neighbor FABRIC activate
  redistribute connected
 exit-address-family
{% if node[inventory_hostname]["routing"]["bgp"]["underlay"] is defined %}
{% if node[inventory_hostname]["routing"]["bgp"]["underlay"]["evpn"] is defined %}
 address-family l2vpn evpn
  advertise ipv4 unicast
  advertise ipv6 unicast
 exit-address-family
{% endif %}
{% endif %}
 !
{% endfor %}
{% endif %}

route-map loopbacks permit 10
 match interface lo
!
line vty
!
